"""
Malte Braack, Naveen Kumar Parameswaran
CAU, Kiel University, Germany

https://www.pec3.org/events/school2022/

Exercise Class 3 - Numerical Optimization
"""

#------------------------------------------
# Subroutines
#------------------------------------------

# This class describes a function with the functionalties
# to return the value, the gradient and the Hessian
#
class MyFunction:

	def __init__(self):
		pass

	def value(self,x):
		return 0.1*x[0]*x[0]+x[1]*x[1]
		
	def grad(self,x):
		return  [0.2*x[0] , 2.*x[1]]
		
	def Hessian(self,x):
		return [ [0.2,0.] , [0.,2.] ]
		
#------------------------------------------

def Exercise1(x):
	f = MyFunction()
	print ("f(x0) =", f.value(x))
	print ("f'(x0) =", f.grad(x))
	print ("f''(x0) =", f.Hessian(x))
	
#------------------------------------------
# Main programme
#------------------------------------------

print ("\nExercise 1:")
x0 =  [0.1 , 1.]
Exercise1(x0)

